## pypy3 7.3.11+dfsg

=== Makefile ===

all: pypy3-c cffi_imports

PYPY_EXECUTABLE := $(shell which pypy)

ifeq ($(PYPY_EXECUTABLE),)
RUNINTERP = python
else
RUNINTERP = $(PYPY_EXECUTABLE)
endif

URAM := $(shell $(RUNINTERP) -c "import sys; print(4.5 if sys.maxint>1<<32 else 2.5)")

JOBS=$(subst -j,--make-jobs ,$(filter -j%, $(MAKEFLAGS)))

.PHONY: pypy-c cffi_imports

pypy3-c:
	@echo
	@echo "===================================================================="
ifeq ($(PYPY_EXECUTABLE),)
	@echo "Building a regular (jitting) version of PyPy, using CPython."
	@echo "This takes around 2 hours and $(URAM) GB of RAM."
	@echo "Note that pre-installing a PyPy binary would reduce this time"
	@echo "and produce basically the same result."
else
	@echo "Building a regular (jitting) version of PyPy, using"
	@echo "$(PYPY_EXECUTABLE) to run the translation itself."
	@echo "This takes up to 1 hour and $(URAM) GB of RAM."
endif
	@echo
	@echo "For more control (e.g. to use multiple CPU cores during part of"
	@echo "the process) you need to run \`\`rpython/bin/rpython'' directly."
	@echo "For more information see \`\`http://pypy.org/download.html''."
	@echo "===================================================================="
	@echo
	@sleep 5
	cd pypy/goal && $(RUNINTERP) ../../rpython/bin/rpython $(JOBS) -Ojit targetpypystandalone.py

cffi_imports: pypy-c
	cd lib_pypy && ../pypy/goal/pypy3-c pypy_tools/build_cffi_imports.py || /bin/true

=== debian/changelog ===
pypy3 (7.3.11+dfsg-2+deb12u3) bookworm; urgency=medium

  * Security patches to the standard library:
    - CVE-2023-27043: Parse email addresses with special characters,
      correctly.
    - CVE-2024-9287: Quote path names in venv activation scripts.
    - CVE-2024-4032: Fix private IP address ranges.
    - CVE-2024-6232: Fix ReDoS when parsing tarfile headers.
    - CVE-2024-8088: Avoid infinite loop in zip file parsing.
    - CVE-2024-6923: Encode newlines in headers in the email module.
    - CVE-2024-7592: Quadratic complexity parsing cookies with backslashes.
    - CVE-2024-11168: Ensure addresses in brackets are valid IPv6 addresses.
  * Clean the python 2.7 source tree.
  * Clean cffi modules C source, lex and yacc tabs.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 23 Dec 2024 16:22:45 -0400

pypy3 (7.3.11+dfsg-2+deb12u2) bookworm; urgency=medium

  * Security patches to the standard library:
    - Apply cPython upstream security fix for CVE-2023-24329:
      Strip C0 control and space characters in urlsplit.
    - Apply cPython upstream security fix for CVE-2023-40217:
      Avoid bypass TLS of handshake protections on closed sockets.
    - Apply cPython upstream security fix for CVE-2023-6597:
      tempfile.TemporaryDirectory: fix symlink bug in cleanup.
    - Apply cPython upstream security fix for CVE-2024-0450:
      Protect zipfile from "quoted-overlap" zipbomb.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 01 May 2024 20:39:38 -0400

pypy3 (7.3.11+dfsg-2+deb12u1) bookworm; urgency=medium

  * Avoid an rpython assertion error in the JIT if integer ranges don't
    overlap in a loop. (Closes: #1062460)

 -- Stefano Rivera <stefanor@debian.org>  Thu, 01 Feb 2024 20:41:13 -0400

pypy3 (7.3.11+dfsg-2) unstable; urgency=medium

  * Mark pypy3 as being EXTERNALLY-MANAGED.
    - Add a NEWS entry explaining this.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 06 Feb 2023 10:12:43 -0400

pypy3 (7.3.11+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 30 Dec 2022 09:29:42 -0400

pypy3 (7.3.10+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch fpic-archs, superseded upstream (--shared by default).

 -- Stefano Rivera <stefanor@debian.org>  Tue, 06 Dec 2022 15:59:19 -0400

pypy3 (7.3.10~rc3+dfsg-2) experimental; urgency=medium

  * Fix the arch-indep build, if we want to avoid a full build we can only
    ship static headers in the arch-indep -dev package.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 25 Nov 2022 18:38:20 +0200

pypy3 (7.3.10~rc3+dfsg-1) experimental; urgency=medium

  * Upload to experimental.
  * New upstream release.
    - Switch to the 3.9 branch, now that it's out of beta.
  * Refresh patches.
  * Update copyright.
  * Bump dpkg-dev build-dep to 1.20.1, which provides buildopts.mk.
  * The upstream buildsystem produces pypy3.9-c, adapt to that.
  * Change the way we split out arch-dependent headers. Upstream now generates
    more headers.
  * Correct the installed paths of pypy3-lib-testsuite, broken since
    7.3.8+dfsg-1.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 25 Nov 2022 10:44:29 +0200

pypy3 (7.3.9+dfsg-5) unstable; urgency=medium

  * autopkgtests: Check PEP-660 editable installs, and PEP-517-driven
    installs.
  * Patch: Resolve CVE-2022-37454, a buffer overflow in SHA-3 (Keccak)
    (LP: #1995197)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 30 Oct 2022 10:55:02 +0200

pypy3 (7.3.9+dfsg-4) unstable; urgency=medium

  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 09 Aug 2022 14:12:13 +0200

pypy3 (7.3.9+dfsg-3) experimental; urgency=medium

  * Don't assume we're building with pypy, when "pypy" appears in the path of
    the python interpreter, fixes FTBFS on 32bit archs.
  * Build cPython 2.7 with --with-system-expat and --with-system-ffi, fixing
    FTBFS on mips64el.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 08 Aug 2022 16:28:35 +0200

pypy3 (7.3.9+dfsg-2) experimental; urgency=medium

  * Upload to experimental.
  * Add python2.7 source as the cpython27 component to the source package.
  * Build cPython 2.7 from source, to build PyPy3 with (Closes: #937510)
    - Document cPython2.7 source in debian/copyright.
  * Bump debhelper-compat to 11, we can't backport to Ubuntu <=16.04, any
    more, for other reasons so this is a reasonable floor.
  * Port debian/scripts/*.py to Python 3.
  * Bump Standards-Version to 4.6.1, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 06 Aug 2022 20:02:17 +0200

=== debian/control ===
Source: pypy3
Section: python
Priority: optional
Maintainer: Stefano Rivera <stefanor@debian.org>
Build-Depends:
 debhelper-compat (= 11),
 dh-autoreconf,
 dh-exec,
 dpkg-dev (>= 1.20.1~),
 libbz2-dev,
 libexpat1-dev,
 libffi-dev,
 libgdbm-dev,
 liblzma-dev,
 libncurses-dev,
 libsqlite3-dev,
 libssl-dev | libssl1.0-dev,
 netbase,
 pkg-config,
 procps,
 python3-dev,
 python3-pip-whl,
 python3-setuptools-whl,
 python3-sphinx (>= 1.0.7+dfsg),
 tcl-dev,
 tk-dev,
 valgrind-if-available,
 zlib1g-dev
Build-Depends-Indep: graphviz
Standards-Version: 4.6.1
Homepage: https://www.pypy.org/
Vcs-Git: https://salsa.debian.org/debian/pypy3.git
Vcs-Browser: https://salsa.debian.org/debian/pypy3
Rules-Requires-Root: no

Package: pypy3
Architecture: any
Depends: ${misc:Depends}
Breaks: pypy3-dev (<< ${source:Version}), python3-virtualenv (<< 20.13.0+ds-2~)
Provides: ${pypy3-abi}
Suggests: pypy3-doc, pypy3-tk (= ${binary:Version})
Pre-Depends:
 pypy3-lib (= ${binary:Version}),
 ${misc:Pre-Depends},
 ${shlibs:Pre-Depends}
Description: fast alternative implementation of Python 3.x - PyPy interpreter
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x). It has several advantages and distinct features:
  * Speed: thanks to its Just-in-Time compiler (on x86), Python programs often
    run faster on PyPy.
  * Memory usage: large, memory-hungry Python programs might end up taking less
    space than they do in CPython.
  * Compatibility: PyPy is highly compatible with existing Python code.
    It supports ctypes and can run popular Python libraries like twisted and
    django.
  * Stackless: PyPy supports stackless mode on most platforms, providing
    micro-threads for massive concurrency.
 .
 This package contains the PyPy interpreter for Python 3.x.

Package: pypy3-tk
Architecture: any
Depends: pypy3 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Tkinter module for PyPy (an alternative Python 3.x interpreter)
 A module for writing portable GUI applications with PyPy using Tk.
 Also known as Tkinter.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-lib
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}
Provides: ${cffi:Provides}
Description: standard library for PyPy (an alternative Python 3.x interpreter)
 The PyPy standard library. This is a combination of modules, copied directly
 from cpython, modified cpython modules, and modules entirely re-implemented
 (usually in pure Python, where they are C extensions in cpython).
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-lib-testsuite
Architecture: all
Depends: pypy3, pypy3-lib (>= ${source:Version}), ${misc:Depends}
Description: standard library test suite for PyPy (an alternative Python 3,x interpreter)
 The complete test suite for the PyPy standard library.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python3-doc
Multi-Arch: foreign
Description: developer Documentation for PyPy (an alternative Python 3.x interpreter)
 The Developer documentation for PyPy. This mostly covers the internals of
 PyPy, and development of PyPy itself.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-dev
Architecture: all
Depends: pypy3 (>= ${source:Version}), ${misc:Depends}
Provides: libpypy-dev
Description: header files for PyPy (an alternative Python 3.x interpreter)
 Header files for compiling cpython C extension modules for use with PyPy.
 Note that pure Python modules will probably perform better.
 .
 PyPy supports a subset of cpython's C API through its CPyExt subsystem.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

Package: pypy3-venv
Architecture: all
Depends:
 pypy3 (>= ${source:Version}),
 python3-pip-whl,
 python3-setuptools-whl,
 ${misc:Depends}
Description: fast alternative implementation of Python 3.x - PyPy venv module
 This package will install the dependencies of the PyPy 3 venv module.
 .
 PyPy is a fast, compliant alternative implementation of the Python language
 (3.x).

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_OPTION_PARALLEL = 1
include /usr/share/dpkg/buildopts.mk

# PyPy doesn't harden well, and handles opt and debug itself
BUILDFLAGS_ENV := DEB_BUILD_MAINT_OPTIONS=hardening=-stackprotector,-fortify
BUILDFLAGS_ENV += DEB_CFLAGS_MAINT_STRIP="-O0 -O1 -O2 -O3 -Os -Ofast -g"
export CFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get CFLAGS)
export LDFLAGS = $(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:
	# This rule left intentionally empty

override_dh_auto_build-arch: pypy/goal/pypy3.9-c
	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs

	# Build cffi modules
	pypy/goal/pypy3.9-c lib_pypy/pypy_tools/build_cffi_imports.py
	debian/scripts/verify-all-headers-present.py

override_dh_auto_build-indep:
	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs

cpython27/python:
	dh_autoreconf -D cpython27
	cd cpython27 && ./configure --with-system-ffi --with-system-expat
	cd cpython27 && $(MAKE) -j$(DEB_BUILD_OPTION_PARALLEL)

pypy/goal/pypy3.9-c: cpython27/python
	debian/scripts/translate.sh --python $(CURDIR)/cpython27/python

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch: export TMPDIR = $(CURDIR)/build-tests-tmp
override_dh_auto_test-arch: export HOME = $(TMPDIR)
override_dh_auto_test-arch:
	rm -rf $(TMPDIR) build-tests
	mkdir $(TMPDIR) build-tests
	ln -sf lib_pypy/cffi/_pycparser/ pycparser
	# Test failures currently ignored
	PYTHONPATH=. cpython27/python -u \
		testrunner/runner.py \
		--logfile=build-tests/pytest-A.log \
		--config=pypy/pytest-A.cfg \
		--root=pypy || true
	rm pycparser
	TERM=$${TERM:-dumb} cpython27/python -u \
		pypy/test_all.py \
		--pypy=pypy/goal/pypy3.9-c \
		--resultlog=build-tests/lib-python.log \
		lib-python || true
	cpython27/python -u pypy/test_all.py \
		--pypy=pypy/goal/pypy3.9-c \
		--resultlog=build-tests/pypy-c.log \
		pypy/module/pypyjit/test_pypy_c || true
endif

override_dh_auto_install:
	debian/scripts/gen-backend-versions.py

override_dh_auto_clean:
	sed 's/^@/#/' cpython27/Makefile.pre.in | $(MAKE) -C cpython27 -f - srcdir=. distclean
	dh_auto_clean

override_dh_fixperms-arch:
	debian/scripts/cleanup-lib.sh pypy3-lib
	find debian/pypy3-tk \( -name '*.pyc' -o -name '__pycache__' \) -delete
	# Fix interpreters
	find debian/pypy3-tk \
	     -name '*.py' -print0 \
	     | xargs -0 sed -i -e '1s|^#!.*python.*|#!/usr/bin/pypy3|'
	dh_fixperms -a

override_dh_fixperms-indep:
	debian/scripts/cleanup-lib.sh pypy3-lib-testsuite
	dh_fixperms -i

override_dh_sphinxdoc-arch:
	# dh_sphinxdoc doesn't fail silently when there are no docs

override_dh_compress:
	dh_compress -X.inv -X.txt

override_dh_shlibdeps-arch:
	dh_shlibdeps --package=pypy3 -- -dPre-Depends
	dh_shlibdeps --arch --remaining-packages

override_dh_installdeb:
	debian/scripts/maintscript.sh pypy3.preinst
	debian/scripts/maintscript.sh pypy3.postinst
	debian/scripts/maintscript.sh pypy3.prerm
	debian/scripts/maintscript.sh pypy3-lib.prerm
	dh_installdeb

HG_REPO ?= https://bitbucket.org/pypy/pypy
REV = $(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
DVER = $(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
UVER = $(shell echo $(DVER) | sed -e 's/~//')
get-packaged-orig-source:
	@echo "You can build this from a local repo by supplying the HG_REPO variable"
	rm -rf pypy3-$(DVER).orig
	hg clone $(HG_REPO) pypy3-$(DVER).orig
ifeq (,$(REV))
	cd pypy3-$(DVER).orig && hg up -r release-pypy3.9-v$(UVER)
else
	cd pypy3-$(DVER).orig && hg up -r $(REV)
endif
	rm -rf pypy3-$(DVER).orig/.hg*
	rm pypy3-$(DVER).orig/lib-python/*/distutils/command/*.exe
	rm pypy3-$(DVER).orig/rpython/rlib/test/loadtest/loadtest*.dll
	rm -rf pypy3-$(DVER).orig/lib-python/*/ensurepip/_bundled/
	tar -cJ --owner root --group root --mode a+rX \
	    -f pypy3_$(DVER)+dfsg.orig.tar.xz pypy3-$(DVER).orig
	rm -rf pypy3-$(DVER).orig

=== debian/watch ===
version=4

# To repack, run debian/rules get-packaged-orig-source
opts=dversionmangle=s/\+dfsg// \
	https://downloads.python.org/pypy/pypy3.9-v([0-9.]+)-src.tar.bz2

## pypy3 7.3.12+dfsg

=== debian/changelog ===
pypy3 (7.3.12+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 16 Jun 2023 14:15:58 -0400

pypy3 (7.3.12~rc2+dfsg-1) experimental; urgency=medium

  * New upstream RC.
  * Refresh patches.
  * Drop patch apptest-socket_connection-refused, superseded upstream.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 28 May 2023 18:27:49 -0400

pypy3 (7.3.12~rc1+dfsg-1) experimental; urgency=medium

  * New upstream RC.
  * Update copyright.
  * Clean the python 2.7 source tree.
  * Clean cffi modules C source, lex and yacc tabs.
  * Organize patch series into topics.
  * Patch: Resolve some benign network-related apptest failures.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 13 May 2023 19:28:55 -0400

## pypy3 7.3.15%2Bdfsg

=== debian/watch ===
version=4

opts=dversionmangle=auto,oversionmangle=s/$/+dfsg/ \
	https://downloads.python.org/pypy/pypy3.9-v([0-9.]+)-src.tar.bz2
opts=component=cpython27,dversionmangle=s/.*/2.7.18/ \
	https://www.python.org/ftp/python/2.7.18/Python-([0-9.]+).tar.xz

## pypy3 7.3.15+dfsg

=== requirements.txt ===

# because the win64 build worker get confused whether it is 32 or 64-bit
--no-binary cffi
cffi>=1.4.0

# parse log files in rvmprof tests
vmprof>=0.4.13; 'x86' in platform.machine

# hypothesis is used for test generation on untranslated tests
hypothesis<4.40
enum34>=1.1.2

# this is used by pypy/module/_hpy_universal/_vendored/hpy/devel
pathlib

=== extra_tests/requirements.txt ===
pytest<=6.0
setuptools<65.0
hypothesis
vmprof
filelock

=== debian/changelog ===
pypy3 (7.3.15+dfsg-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 06:50:16 +0000

pypy3 (7.3.15+dfsg-1build2) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 05 Mar 2024 01:22:58 +0000

pypy3 (7.3.15+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 21:06:28 +0000

pypy3 (7.3.15+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update copyright.
  * Upstream migrated to GitHub, update metadata.
  * Migrate orig tarball building to uscan.
  * Drop Build-Depends on dh-autoreconf, no longer needed.
  * Bump Standards-Version to 4.6.2, no changes needed.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 18 Jan 2024 13:13:42 -0400

pypy3 (7.3.14+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Update copyright.
  * Build-Depend on python3-sphinx-rtd-theme and python3-sphinx-issues.
  * Reorganize tests to run pypyjit tests that need pycparser earlier.
  * Clean another lextab and yacctab location.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 25 Dec 2023 15:41:10 -0400

pypy3 (7.3.13+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Fixes CVE-2023-40217.
  * Refresh patches.
  * Patch: Support Sphinx 7.1 by specifying a substitutable caption for
    extlinks (Closes: #1042638)

 -- Stefano Rivera <stefanor@debian.org>  Fri, 29 Sep 2023 16:38:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: pypy3
 Section: python
 Priority: optional
-Maintainer: Stefano Rivera <stefanor@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stefano Rivera <stefanor@debian.org>
 Build-Depends:
  debhelper-compat (= 11),
- dh-autoreconf,
  dh-exec,
  dpkg-dev (>= 1.20.1~),
  libbz2-dev,
@@ -22,12 +22,14 @@
  python3-pip-whl,
  python3-setuptools-whl,
  python3-sphinx (>= 1.0.7+dfsg),
+ python3-sphinx-issues,
+ python3-sphinx-rtd-theme,
  tcl-dev,
  tk-dev,
  valgrind-if-available,
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy3.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy3

=== debian/rules ===
--- 
+++ 
@@ -46,16 +46,16 @@
 		--logfile=build-tests/pytest-A.log \
 		--config=pypy/pytest-A.cfg \
 		--root=pypy || true
+	cpython27/python -u pypy/test_all.py \
+		--pypy=pypy/goal/pypy3.9-c \
+		--resultlog=build-tests/pypy-c.log \
+		pypy/module/pypyjit/test_pypy_c || true
 	rm pycparser
 	TERM=$${TERM:-dumb} cpython27/python -u \
 		pypy/test_all.py \
 		--pypy=pypy/goal/pypy3.9-c \
 		--resultlog=build-tests/lib-python.log \
 		lib-python || true
-	cpython27/python -u pypy/test_all.py \
-		--pypy=pypy/goal/pypy3.9-c \
-		--resultlog=build-tests/pypy-c.log \
-		pypy/module/pypyjit/test_pypy_c || true
 endif
 
 override_dh_auto_install:
@@ -94,24 +94,3 @@
 	debian/scripts/maintscript.sh pypy3.prerm
 	debian/scripts/maintscript.sh pypy3-lib.prerm
 	dh_installdeb
-
-HG_REPO ?= https://bitbucket.org/pypy/pypy
-REV = $(shell dpkg-parsechangelog | sed -rne 's,^Version: .*hg([0-9]+).*,\1,p')
-DVER = $(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+)\+dfsg-.*,\1,p')
-UVER = $(shell echo $(DVER) | sed -e 's/~//')
-get-packaged-orig-source:
-	@echo "You can build this from a local repo by supplying the HG_REPO variable"
-	rm -rf pypy3-$(DVER).orig
-	hg clone $(HG_REPO) pypy3-$(DVER).orig
-ifeq (,$(REV))
-	cd pypy3-$(DVER).orig && hg up -r release-pypy3.9-v$(UVER)
-else
-	cd pypy3-$(DVER).orig && hg up -r $(REV)
-endif
-	rm -rf pypy3-$(DVER).orig/.hg*
-	rm pypy3-$(DVER).orig/lib-python/*/distutils/command/*.exe
-	rm pypy3-$(DVER).orig/rpython/rlib/test/loadtest/loadtest*.dll
-	rm -rf pypy3-$(DVER).orig/lib-python/*/ensurepip/_bundled/
-	tar -cJ --owner root --group root --mode a+rX \
-	    -f pypy3_$(DVER)+dfsg.orig.tar.xz pypy3-$(DVER).orig
-	rm -rf pypy3-$(DVER).orig

## pypy3 7.3.16+dfsg

=== debian/changelog ===
pypy3 (7.3.16+dfsg-2) unstable; urgency=medium

  * Patch: Fix a constant folding bug that caused FTBFS on s390x.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 26 Apr 2024 09:12:11 -0400

pypy3 (7.3.16+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * De-vendor expat (vendored upstream in 7.3.16)
  * Update copyright
  * Handle .devX cffi versions.
  * Upstream dropped pystone.py.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 24 Apr 2024 15:35:11 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: pypy3
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Stefano Rivera <stefanor@debian.org>
+Maintainer: Stefano Rivera <stefanor@debian.org>
 Build-Depends:
  debhelper-compat (= 11),
  dh-exec,

## pypy3 7.3.17+dfsg

=== debian/changelog ===
pypy3 (7.3.17+dfsg-2ubuntu1) oracular; urgency=medium

  * Allow output to stderr in all autopkgtests to avoid
    failure on Launchpad arm64 runners with:
    Warning: cannot find your CPU L2 & L3 cache size in
    /sys/devices/system/cpu/cpuX/cache 

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 30 Sep 2024 11:38:25 +0000

pypy3 (7.3.17+dfsg-2) unstable; urgency=medium

  * Patch, work-around FTBFS on 32-bit archs with GCC-14 by suppressing
    -Wincompatible-pointer-types.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 31 Aug 2024 14:43:58 +0200

pypy3 (7.3.17+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Drop patches, superseded upstream: bdist-wininst-notfound,
    ensurepip-wheels, test_readline-invalidterminal,
    rlcompleter-invalidterminal, null-pointer-constfold.
  * Call dpkg with LC_ALL=C.UTF8 (LP: #2075337)
  * Switch to the 3.10-compatible version (Closes: #1072016)
    - graminit.h is no longer generated.
  * Drop bdist_wininst *.exe files from exclusion, they were dropped upstream.
  * Drop patch ctypes-arm, superseded upstream in 2.7.5.
  * Move ensurepip module into pypy3-venv.
  * New patch sysconfig-debian-schemes, taking over part of
    distutils-install-layout.
  * Drop plat-gnukfreebsd, Debian GNU/kFreeBSD is no longer being developed.
  * Enable continuation and JIT on RISC-V 64.
  * Handle site-packages/README.txt rename.
  * Bump Standards-Version to 4.7.0, no changes needed.
  * Build-Depend on pkgconf instead of pkg-config.
  * Patch: Simplify the sysconfigdata name when multiarch.
  * Build and install sysconfigdata.
  * Patch: Use static sysconfigdata.
  * Configure WHEEL_PKG_DIR in sysconfigdata.
  * Patches: Use Europe/Kyiv as a test timezone.
  * Build-Depend on tzdata.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 30 Aug 2024 20:10:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pypy3
 Section: python
 Priority: optional
-Maintainer: Stefano Rivera <stefanor@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Stefano Rivera <stefanor@debian.org>
 Build-Depends:
  debhelper-compat (= 11),
  dh-exec,
@@ -15,7 +16,7 @@
  libsqlite3-dev,
  libssl-dev | libssl1.0-dev,
  netbase,
- pkg-config,
+ pkgconf,
  procps,
  python3-dev,
  python3-pip-whl,
@@ -25,10 +26,11 @@
  python3-sphinx-rtd-theme,
  tcl-dev,
  tk-dev,
+ tzdata,
  valgrind-if-available,
  zlib1g-dev
 Build-Depends-Indep: graphviz
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://www.pypy.org/
 Vcs-Git: https://salsa.debian.org/debian/pypy3.git
 Vcs-Browser: https://salsa.debian.org/debian/pypy3

=== debian/rules ===
--- 
+++ 
@@ -15,12 +15,13 @@
 override_dh_auto_configure:
 	# This rule left intentionally empty
 
-override_dh_auto_build-arch: pypy/goal/pypy3.9-c
+override_dh_auto_build-arch: pypy/goal/pypy3.10-c
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 
 	# Build cffi modules
-	pypy/goal/pypy3.9-c lib_pypy/pypy_tools/build_cffi_imports.py
+	pypy/goal/pypy3.10-c lib_pypy/pypy_tools/build_cffi_imports.py
 	debian/scripts/verify-all-headers-present.py
+	debian/scripts/gen-sysconfigdata.sh
 
 override_dh_auto_build-indep:
 	$(MAKE) -C pypy/doc html BUILDDIR=$(CURDIR)/build-docs
@@ -30,7 +31,7 @@
 	cd cpython27 && ./configure --with-system-ffi --with-system-expat
 	cd cpython27 && $(MAKE) -j$(DEB_BUILD_OPTION_PARALLEL)
 
-pypy/goal/pypy3.9-c: cpython27/python
+pypy/goal/pypy3.10-c: cpython27/python
 	debian/scripts/translate.sh --python $(CURDIR)/cpython27/python
 
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
@@ -47,13 +48,13 @@
 		--config=pypy/pytest-A.cfg \
 		--root=pypy || true
 	cpython27/python -u pypy/test_all.py \
-		--pypy=pypy/goal/pypy3.9-c \
+		--pypy=pypy/goal/pypy3.10-c \
 		--resultlog=build-tests/pypy-c.log \
 		pypy/module/pypyjit/test_pypy_c || true
 	rm pycparser
 	TERM=$${TERM:-dumb} cpython27/python -u \
 		pypy/test_all.py \
-		--pypy=pypy/goal/pypy3.9-c \
+		--pypy=pypy/goal/pypy3.10-c \
 		--resultlog=build-tests/lib-python.log \
 		lib-python || true
 endif

=== debian/watch ===
version=4

opts=dversionmangle=auto,oversionmangle=s/$/+dfsg/ \
	https://downloads.python.org/pypy/pypy3.10-v([0-9.]+)-src.tar.bz2
opts=component=cpython27,dversionmangle=s/.*/2.7.18/ \
	https://www.python.org/ftp/python/2.7.18/Python-([0-9.]+).tar.xz

## pypy3 7.3.18+dfsg

=== debian/changelog ===
pypy3 (7.3.18+dfsg-2) unstable; urgency=medium

  * Patch: Fix vmprof build on riscv64.
  * Patch: Fix CVE-2025-0938: Disallow square brackets in domain names in
    urllib.parse.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 10 Feb 2025 09:08:23 -0400

pypy3 (7.3.18+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Switch to the 3.11-compatible version.
  * Refresh patches.
  * Drop patches debian/prefer-static-sysconfigdata,
    stdlib/CVE-2023-27043-email-parseaddr,
    stdlib/CVE-2024-9287-venv-activation-templates, tests/test_email_kyiv, and
    tests/test_time_kyiv. Superseded upstream.
  * Patches: Avoid new compilation failures with GCC-14.
  * Handle a missed rename from 3.10 to 3.11, upstream.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 08 Feb 2025 16:37:47 -0400

pypy3 (7.3.17+dfsg-3) unstable; urgency=medium

  * Avoid writing build environment paths into _sysconfigdata.
  * Do a wide build of Python 2.7 for the translation.
  * Patch: CVE-2024-9287: Quote path names in venv activation scripts.
    (Closes: #1089117)
  * Patch: CVE-2023-27043: Parse email addresses with special characters,
    correctly. (Closes: #1072179)

 -- Stefano Rivera <stefanor@debian.org>  Thu, 05 Dec 2024 19:29:26 -0400

## pypy3 7.3.19+dfsg

=== debian/changelog ===
pypy3 (7.3.19+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Drop patches: upstream/path-max, upstream/gcc-14-vmprof,
    upstream/gcc-14-sqlite3, upstream/vimprof-riscv, all superseded upstream.
  * Revert the change for the missed rename from 3.10 to 3.11, upstream.
  * Update copyright.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 26 Feb 2025 17:27:18 -0400

=== debian/rules ===
--- 
+++ 
@@ -15,11 +15,11 @@
 override_dh_auto_configure:
 	# This rule left intentionally empty
 
-override_dh_auto_build-arch: pypy/goal/pypy3.10-c
+override_dh_auto_build-arch: pypy/goal/pypy3.11-c
 	$(MAKE) -C pypy/doc man BUILDDIR=$(CURDIR)/build-docs
 
 	# Build cffi modules
-	pypy/goal/pypy3.10-c lib_pypy/pypy_tools/build_cffi_imports.py
+	pypy/goal/pypy3.11-c lib_pypy/pypy_tools/build_cffi_imports.py
 	debian/scripts/verify-all-headers-present.py
 	debian/scripts/gen-sysconfigdata.sh
 
@@ -28,10 +28,10 @@
 
 cpython27/python:
 	dh_autoreconf -D cpython27
-	cd cpython27 && ./configure --with-system-ffi --with-system-expat
+	cd cpython27 && ./configure --with-system-ffi --with-system-expat --enable-unicode=ucs4
 	cd cpython27 && $(MAKE) -j$(DEB_BUILD_OPTION_PARALLEL)
 
-pypy/goal/pypy3.10-c: cpython27/python
+pypy/goal/pypy3.11-c: cpython27/python
 	debian/scripts/translate.sh --python $(CURDIR)/cpython27/python
 
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
@@ -48,13 +48,13 @@
 		--config=pypy/pytest-A.cfg \
 		--root=pypy || true
 	cpython27/python -u pypy/test_all.py \
-		--pypy=pypy/goal/pypy3.10-c \
+		--pypy=pypy/goal/pypy3.11-c \
 		--resultlog=build-tests/pypy-c.log \
 		pypy/module/pypyjit/test_pypy_c || true
 	rm pycparser
 	TERM=$${TERM:-dumb} cpython27/python -u \
 		pypy/test_all.py \
-		--pypy=pypy/goal/pypy3.10-c \
+		--pypy=pypy/goal/pypy3.11-c \
 		--resultlog=build-tests/lib-python.log \
 		lib-python || true
 endif

=== debian/tests/control ===
Tests: byte-compilation
Depends: pypy3, shunit2
Restrictions: allow-stderr

Tests: command-line
Depends: pypy3, shunit2
Restrictions: superficial, allow-stderr

Tests: import-paths
Depends: pypy3-venv, python3-six, shunit2
# six is just there to ensure dist-packages exists
Restrictions: allow-stderr

Tests: pypy3-tk
Depends: pypy3-tk, shunit2
Restrictions: superficial, allow-stderr

Tests: module-install-local
Depends: build-essential, pypy3-dev, python3-pip, python3-setuptools, shunit2
Restrictions: needs-root, allow-stderr

Tests: module-install-user
Depends: build-essential, pypy3-dev, python3-pip, python3-setuptools, shunit2
Restrictions: allow-stderr

Tests: module-install-venv
Depends: build-essential, pypy3-dev, pypy3-venv, python3-wheel-whl, shunit2
Restrictions: allow-stderr

Tests: module-install-virtualenv
Depends: build-essential, pypy3-dev, shunit2, virtualenv
Restrictions: allow-stderr

## pypy3 7.3.20+dfsg

=== requirements.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 cffi>=1.4.0
 
 # parse log files in rvmprof tests
-vmprof>=0.4.13; 'x86' in platform.machine
+vmprof>=0.4.13
 
 # hypothesis is used for test generation on untranslated tests
 hypothesis<4.40
@@ -12,3 +12,9 @@
 
 # this is used by pypy/module/_hpy_universal/_vendored/hpy/devel
 pathlib
+
+# needed for some test compatibility with python3
+future
+
+# for app_main tests
+pexpect

=== debian/changelog ===
pypy3 (7.3.20+dfsg-4) unstable; urgency=medium

  * Patch: Fix AssertionError in AST Compiler (Closes: #1119266).

 -- Stefano Rivera <stefanor@debian.org>  Tue, 28 Oct 2025 17:14:54 +0200

pypy3 (7.3.20+dfsg-3) unstable; urgency=medium

  * Build cpython2.7 with --std=c17 (Closes: #1097670)

 -- Stefano Rivera <stefanor@debian.org>  Mon, 08 Sep 2025 18:28:00 +0200

pypy3 (7.3.20+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 16 Aug 2025 18:43:53 +0200

pypy3 (7.3.20+dfsg-1) experimental; urgency=medium

  * New upstream release.
    - Fixes: CVE-2025-4138, CVE-2025-4330, CVE-2025-4435, CVE-2025-4517, and
      CVE-2024-12718.
    - Upload to experimental, due to the freeze.
  * Refresh patches.
  * Drop patch for CVE-2025-0938, superseded upstream.
  * Patch for CVE-2025-6069: Fix quadratic complexity in processing special
    input in HTMLParser.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 05 Jul 2025 17:00:41 +0200

pypy3 (7.3.19+dfsg-2) unstable; urgency=medium

  * Drop test depends on python3-wheel-whl, setuptools has native bdist_wheel
    support.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 10 Apr 2025 21:01:39 -0400

=== debian/tests/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
 Restrictions: allow-stderr
 
 Tests: module-install-venv
-Depends: build-essential, pypy3-dev, pypy3-venv, python3-wheel-whl, shunit2
+Depends: build-essential, pypy3-dev, pypy3-venv, shunit2
 Restrictions: allow-stderr
 
 Tests: module-install-virtualenv

=== debian/watch ===
version=4

opts=dversionmangle=auto,oversionmangle=s/$/+dfsg/ \
	https://downloads.python.org/pypy/pypy3.11-v([0-9.]+)-src.tar.bz2
opts=component=cpython27,dversionmangle=s/.*/2.7.18/ \
	https://www.python.org/ftp/python/2.7.18/Python-([0-9.]+).tar.xz
